// Required modules
const request		= require('request-promise');

const contentRgx = /window\.UGAPP\.store\.page = ({.+});/;

const populateDefaultArgs = args => {
	if (!args.termsArr) args.termsArr = [];
	if (!args.page) args.page = 1;
	return args;
};

const getURL = args => {
	args = populateDefaultArgs(args);
	const ugPre = 'https://www.ult' + 'imate-gui' + 'tar.com/search.php';
	if (args.artist) args.termsArr.unshift(args.artist);
	const terms = encodeURI(args.termsArr.join(' '));
	let url = ugPre + '?title=' + terms;
	if (args.type) url += '&type=' + args.type;
	// if (args.sort) url += '&rating[0]=4&rating[1]=5';
	if (args.page) url += '&page=' + args.page;
	return url;
};

const search = (args, callback) => {
	const url = getURL(args);
	request(url)
		.then(body => {
			const results = JSON.parse(body.match(contentRgx)[1]).data.results;
			callback(null, results);
		})
		.catch(err => {
			callback(err);
		});
};

const getTab = (url, callback) => {
	request(url)
		.then(body => {
			const content = JSON.parse(body.match(contentRgx)[1]).data.tab_view.wiki_tab.content;
			callback(null, content);
		})
		.catch(err => {
			callback(err);
		});
};

const bogusTypes = ['Pro', 'Power'];

module.exports = {
	search,
	getTab,
	bogusTypes
};
